# --- Etapa 1: Build ---
FROM mcr.microsoft.com/dotnet/sdk:9.0 AS build
WORKDIR /src

# Copiamos los archivos .csproj para restaurar dependencias
COPY ["src/Elecciones.Worker/Elecciones.Worker.csproj", "Elecciones.Worker/"]
COPY ["src/Elecciones.Infrastructure/Elecciones.Infrastructure.csproj", "Elecciones.Infrastructure/"]
COPY ["src/Elecciones.Core/Elecciones.Core.csproj", "Elecciones.Core/"]
COPY ["src/Elecciones.Database/Elecciones.Database.csproj", "Elecciones.Database/"]
RUN dotnet restore "Elecciones.Worker/Elecciones.Worker.csproj"

# Copiamos el resto del código fuente
COPY src/. .

# Publicamos el worker
WORKDIR "/src/Elecciones.Worker"
RUN dotnet publish "Elecciones.Worker.csproj" -c Release -o /app/publish

# --- Etapa 2: Final ---
# Usamos la imagen de runtime genérica de .NET, ya que no necesita ASP.NET
FROM mcr.microsoft.com/dotnet/runtime:9.0 AS final
WORKDIR /app
COPY --from=build /app/publish .
ENTRYPOINT ["dotnet", "Elecciones.Worker.dll"]